/** @file
 * @brief ODS Service class header. This class represents the ODS service.
 *
 *
 *
 * @copyright Intra2net AG
 * @license GPLv2
*/

#ifndef ServiceOds_H
#define ServiceOds_H

#include "service.hpp"
#include "logger.hpp"

#include <boost/shared_ptr.hpp>
#include <string>


class ServiceOds : public Service
{

private:

    friend class boost::serialization::access;
    template<class Archive>
    void serialize(Archive & ar, const unsigned int version)
    {
        ar & boost::serialization::base_object<Service>(*this);
    }

    std::string UpdateServer;
    std::string Port;

public:

    typedef boost::shared_ptr<ServiceOds> Ptr;

    ServiceOds();

    ServiceOds(const std::string& _protocol, const std::string& _hostname, const std::string& _login, const std::string& _password, const Logger::Ptr& _logger, const int _update_interval, const int _max_updates_within_interval, const int _max_equal_updates_in_succession, const int dns_cache_ttl);

    ~ServiceOds();

    UpdateErrorCode perform_update(const std::string& ip);
};

#endif
